
typedef struct {
		int		x1, y1, x2, y2 ;
	}
		ClipPart ;

typedef	struct	{
		ClipPart	clip ;
	}
		ClipClass ;


#define	DirectionX	1
#define	DirectionY	2

typedef	struct	{
		int		dir ;
		int		width ;
		int		length ;
		int		min, max ;
		int		top ;
		int		size ;
	}
		SliderPart ;

typedef	struct	{
		ClipPart	clip ;
		SliderPart	slider ;
	}
		SliderClass ;


typedef	struct	{
		int		step ;
	}
		ScrollerPart ;

typedef	struct	{
		ClipPart		clip ;
		SliderPart		slider ;
		ScrollerPart	scroller ;
	}
		ScrollerClass ;

typedef	struct	{
		int			maxh, maxv ;
		int			attr ;
		int			font ;
		int			tabgap ;
		int			cx, cy ;
		char		*buf ;
	}
		TextMapPart ;

typedef	struct	{
		ClipPart	clip ;
		TextMapPart	text ;
	}
		TextMapClass ;

typedef	struct	{
		Sheet	sheet ;
	}
		BitMapPart ;

typedef	struct	{
		ClipPart	clip ;
		BitMapPart	bit ;
	}
		BitMapClass ;

typedef	struct	{
		int		x, y ;
		char	*str ;
		int		max ;
		int		attr ;
		int		font ;
		int		tabgap ;
		int		cur ;
	}
		InputClass ;

/*
	proto -e clip.c slider.c scroller.c textmap.c > temp
	proto -e input.c > temp
*/
extern	void	ClipSet( ClipClass*, int, int, int, int );
extern	void	ClipMove( ClipClass*, int, int );
extern	int		ClipInner( ClipClass*, int, int );
extern	void	ClipGetSize( ClipClass*, int*, int* );
extern	int		ClipOverlap( ClipClass*, ClipClass*, ClipClass* );

extern	void	SliderSet( SliderClass*, int, int, int, int, int, int, int );
extern	int		SliderGetCurrentPosition( SliderClass* );
extern	int		SliderGetPosition( SliderClass*, int, int );
extern	int		SliderSetPosition( DrawBuf*, SliderClass*, int, int );
extern	int		SliderSetDraw( DrawBuf*, SliderClass* );

extern	void	ScrollerSet( ScrollerClass*, int, int, int, int, int, int, int, int );
extern	int		ScrollerGetPosition( ScrollerClass*, int, int );
extern	int		ScrollerSetDraw( DrawBuf*, ScrollerClass* );

extern	void	TextMapSet( TextMapClass*, char*, int, int, int, int, int, int );
extern	TextMapClass	*TextMapOpen( int, int, int, int, int, int );
extern	void	TextMapClose( TextMapClass* );
extern	void	TextMapSetAttr( TextMapClass*, int, int, int );
extern	int		TextMapSetDraw( DrawBuf*, TextMapClass*, int, int );
extern	void	TextMapClear( TextMapClass* );
extern	void	TextMapCursor( TextMapClass*, int );
extern	void	TextMapLocate( TextMapClass*, int, int );
extern	int		TextMapPutString( DrawBuf*, TextMapClass*, char* );

extern	InputClass	*WindowInputOpen( int, int, char*, int );
extern	void	WindowInputSet( InputClass*, int, int, char*, int );
extern	void	WindowInputClose( InputClass* );
extern	void	WindowInputSetAttr( InputClass*, int, int, int );
extern	int		WindowInputSetDraw( DrawBuf*, InputClass* );
extern	int		WindowInputString( DrawBuf*, InputClass*, int );
